unit Dbmbrowfr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, ExtCtrls,
  DBCtrls, Menus, Buttons, DBMoney, OleServer, mon2kdbe_TLB;

type
  TDBMBrowserForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DataSource1: TDataSource;
    DBGrid: TDBGrid;
    IndexComboBox: TComboBox;
    Edit1: TEdit;
    DBNavigator1: TDBNavigator;
    PopupMenu1: TPopupMenu;
    Search1: TMenuItem;
    Opentable1: TMenuItem;
    OpenDialog: TOpenDialog;
    Newtable1: TMenuItem;
    FindDialog: TFindDialog;
    RecNo: TEdit;
    N1: TMenuItem;
    Memoonoff1: TMenuItem;
    FieldsSubMenu: TMenuItem;
    N3: TMenuItem;
    About1: TMenuItem;
    DBMemo1: TDBMemo;
    Splitter1: TSplitter;
    Countfield1: TMenuItem;
    Fillfieldinrecords1: TMenuItem;
    N4: TMenuItem;
    Table: TMoneyTable;
    Dumpheader1: TMenuItem;
    N2: TMenuItem;
    Filter: TMenuItem;
    FilterString1: TMenuItem;
    Rangestart1: TMenuItem;
    Rangeend1: TMenuItem;
    SaveCSVDialog: TSaveDialog;
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure TableAfterOpen(DataSet: TDataset);
    procedure IndexComboBoxChange(Sender: TObject);
    procedure Search2Click(Sender: TObject);
    procedure Opentable1Click(Sender: TObject);
    procedure TableBeforeOpen(DataSet: TDataset);
    procedure TableAfterClose(DataSet: TDataset);
    procedure FindDialogFind(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Memoonoff1Click(Sender: TObject);
    procedure DBGridColEnter(Sender: TObject);
    procedure FieldsSubMenuClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Countfield1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Fillfieldinrecords1Click(Sender: TObject);
    procedure Dumpheader1Click(Sender: TObject);
    procedure FilterString1Click(Sender: TObject);
    procedure FilterClick(Sender: TObject);
    procedure Rangestart1Click(Sender: TObject);
    procedure Rangeend1Click(Sender: TObject);
    procedure ExporttoCSV1Click(Sender: TObject);
  private
    StopFlag: Boolean;
    Found: Boolean;
    FindFlag: Byte;
    RangeStartS, RangeEndS: string;
    procedure SetRO(aRO: Boolean);
    procedure SetKeyValues(Vals: string);
  public
  end;

var
  DBMBrowserForm: TDBMBrowserForm;

var
  TableNameParam: string;
  ReadOnlyParam: Boolean;

resourcestring
  sInput = 'Input';
  scfMask = 'Counting mask (Format procedure mask with one %d parameter)';
  scfStart = 'Start number';
  scfInc = 'Increment';
  scfCount = 'Count (-1..infinity)';
  sfrString = 'String';
  sSetFilter = 'Filter expression';
  sSetFilterRangeStart = 'Range start';
  sSetFilterRangeEnd = 'Range end';
  sAbout = 'Money 2000 SE/S3 Database Browser'#13#10'Copyright (c) 2001,2002,2004 by MandySoft'#13#10'dbmoney@2p.cz'#13#10'http://www.2p.cz';
implementation
uses
  AuxStr, dbiProcs, dbiTypes, DBUtils, dbiErrs, SelTable;

{$R *.DFM}

procedure TDBMBrowserForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Return) and (Shift = []) then
  begin
    if (Edit1.Text <> '') and (Table.IndexFieldNames <> '') then
    begin
      Table.SetKey;
      try
        SetKeyValues(Edit1.Text);
      finally
        Table.Post;
      end;
      Table.GotoNearest;
      Key:= 0;
    end;
  end;
end;

procedure TDBMBrowserForm.SetKeyValues;
var
  I, J: Integer;
begin
  Table.KeyFieldCount:= Table.MasterFieldCount;
  for I:= Table.MasterFieldCount to Table.IndexFieldCount-1 do
  begin
    J:= Pos('|', Vals+'|');
    Table.IndexFields[I].asString:= Copy(Vals, 1, J-1);
    Delete(Vals, 1, J);
    Table.KeyFieldCount:= Table.KeyFieldCount+1;
    if Vals = '' then
      Break;
  end;
end;

procedure TDBMBrowserForm.FormCreate(Sender: TObject);
begin
  Table.FileName:= TableNameParam;
  Table.ReadOnly:= ReadOnlyParam;
  if Table.FileName <> '' then
    OpenDialog.FileName:= Table.FileName;
  if Table.ReadOnly then
    OpenDialog.Options:= OpenDialog.Options + [ofReadOnly];

  if TableNameParam <> '' then
    Table.Open;
end;

procedure TDBMBrowserForm.TableAfterOpen(DataSet: TDataset);
const
  But= [nbEdit, nbPost, nbCancel];
  MaxWidth = 35;
var
  I: Integer;
  MI: TMenuItem;
begin
  if Table.ReadOnly then DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons-But
                    else DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons+But;
  DBNavigator1.Width:= 10; { adjust width }
  for I:= 0 to Table.FieldCount-1 do
    if Table.Fields[I].DisplayWidth > MaxWidth then
      Table.Fields[I].DisplayWidth:= MaxWidth;
  while FieldsSubMenu.Count > 0 do
    FieldsSubMenu.Delete(0);
  for I:= 0 to Table.FieldCount-1 do
  begin
    MI:= TMenuItem.Create(Self);
    MI.Caption:= Table.Fields[I].FieldName;
    MI.Checked:= Table.Fields[I].Visible;
    MI.OnClick:= FieldsSubMenuClick;
    FieldsSubMenu.Add(MI);
  end;
  IndexComboBox.Items.Clear;
  Table.GetIndexNames(IndexComboBox.Items);

  IndexComboBox.Items.Insert(0, '<no index>');
  IndexComboBox.ItemIndex:= 0;
  TableAfterClose(DataSet);
  DBGridColEnter(nil);
end;

procedure TDBMBrowserForm.IndexComboBoxChange(Sender: TObject);
begin
  with IndexComboBox do
    if Text[1] = '<' then Table.IndexFieldNames:= ''
                     else Table.IndexFieldNames:= Text;
end;

procedure TDBMBrowserForm.Search2Click(Sender: TObject);
begin
  Found:= False;
  FindDialog.Execute;
end;

procedure TDBMBrowserForm.Opentable1Click(Sender: TObject);
var
  S: string;
  RO: Boolean;
begin
  if not OpenDialog.Execute then
    Exit;
  TableNameParam:= OpenDialog.Filename;
  RO:= ofReadOnly in OpenDialog.Options;
  if (Sender as TComponent).Tag and $01 <> 0 then
    begin
{          with TDBBrowserForm.Create(nil) do
        Show; }
      S:= ParamStr(0) + ' '+TableNameParam;
      if RO then
        S:= S+' /RO';
      S:= S+#0;
      WinExec(@S[1], SW_SHOW);
    end
  else
    begin
      Table.Close;
      Table.FileName := TableNameParam;
      Table.IndexFieldNames:= '';
      Table.ReadOnly:= RO;
      Table.Open;
    end;
end;

procedure TDBMBrowserForm.TableBeforeOpen(DataSet: TDataset);
begin
  Caption:= Format('DB Browser [%s]', [Table.FileName]);
end;

procedure TDBMBrowserForm.TableAfterClose(DataSet: TDataset);
begin
  FieldsSubMenu.Enabled:= DataSet.Active;
  Search1.Enabled:= DataSet.Active;
  DBMemo1.DataField:= '';
end;

procedure TDBMBrowserForm.FindDialogFind(Sender: TObject);
var
  S, S2: string;
  F, F1, F2: Boolean;
  DownS: Boolean;
  function UpC(const S: string): string;
  begin
    Result:= S;
    if not (frMatchCase in FindDialog.Options) then
      Result:= AnsiUpperCase(Result);
  end;
  procedure Mov;
  begin
    if DownS then Table.Next
             else Table.Prior;
  end;
begin
  if FindFlag <> 0 then
  begin
    StopFlag:= True;
    Exit;
  end;
  StopFlag:= False;
  Inc(FindFlag);
  try
    S:= Trim(UpC(FindDialog.FindText));
    DownS:= frDown in FindDialog.Options;

    if (Length(S) > 1) and (S[1] = '"') and (S[Length(S)] = '"') then
    begin
      Delete(S, 1, 1);
      Delete(S, Length(S), 1);
      F1:= False;
      F2:= False;
    end
  else
    begin
      F1:= S[1] = '*';
      if F1 then Delete(S, 1, 1);
      F2:= S[Length(S)] = '*';
      if F2 then Delete(S, Length(S), 1);
    end;
    if Found then
      Mov;
    repeat
      S2:= UpC(DBGrid.SelectedField.AsString);
      Application.ProcessMessages;
      F:= False;  // unwarning
      if not F1 and not F2 then F:= S = S2 else
      if F1 and F2 then F:= Pos(S, S2) > 0 else
      if F2 then F:= S = Copy(S2, 1, Length(S)) else
      if F1 then F:= S = RStr(S2, Length(S));
      Found:= F;
      if F or StopFlag or (DownS and Table.EOF) or (not DownS and Table.BOF) then Break;
      Mov;
    until False;
  finally
    Dec(FindFlag);
  end;
end;

procedure TDBMBrowserForm.DataSource1DataChange(Sender: TObject;
  Field: TField);
begin
  if Table.Active then
  begin
//    RecNo.Text:= Format('%d/%d', [Table.FieldByName(RecNoFld).AsInteger, _GetRecordCount(Table)]); 
  end
else
  RecNo.Text:= '';
end;

procedure TDBMBrowserForm.Memoonoff1Click(Sender: TObject);
begin
  DBMemo1.Visible:= not DBMemo1.Visible;
  DBMemo1.AutoDisplay:= DBMemo1.Visible;
end;

procedure TDBMBrowserForm.DBGridColEnter(Sender: TObject);
begin
  if DBGrid.SelectedField = nil then DBMemo1.DataField:= '' 
                                else DBMemo1.DataField:= DBGrid.SelectedField.FieldName;
end;

procedure TDBMBrowserForm.FieldsSubMenuClick(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    Checked:= not Checked;
    Table.FieldByName(StripHotKey(Caption)).Visible:= Checked;
  end;
end;

procedure TDBMBrowserForm.About1Click(Sender: TObject);
begin
  ShowMessage(sAbout);
end;


procedure TDBMBrowserForm.Countfield1Click(Sender: TObject);
var
  aStart, aInc, aCount: Integer;
  S, aMask: string;
begin
  aMask:= '%d';
  if not InputQuery(sInput, scfMask, aMask) then
    Exit;
  S:= '1';
  if not InputQuery(sInput, scfStart, S) then
    Exit;
  aStart:= StrToInt(S);
  S:= '1';
  if not InputQuery(sInput, scfInc, S) then
    Exit;
  aInc:= StrToInt(S);
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

    StopFlag:= False;
    while not Table.EOF and not StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= Format(aMask, [aStart]);
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
      Inc(aStart, aInc);
    end;
end;

procedure TDBMBrowserForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Escape) and (Shift = []) then
    StopFlag:= True;
end;

procedure TDBMBrowserForm.Fillfieldinrecords1Click(Sender: TObject);
var
  aCount: Integer;
  S, aString: string;
begin
  aString:= '';
  if not InputQuery(sInput, sfrString, aString) then
    Exit;
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

  SetRO(True);
  try
    StopFlag:= False;
    while not Table.EOF and not StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= aString;
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
    end;
  finally
    SetRO(False);
  end;
end;

procedure TDBMBrowserForm.SetRO;
begin
  DBGrid.Enabled:= not aRO;
  DBMemo1.Enabled:= not aRO;
end;

procedure TDBMBrowserForm.Dumpheader1Click(Sender: TObject);
begin
  Table.DumpHeader('C:\TEMP\DUMP.TXT');
end;

procedure TDBMBrowserForm.FilterString1Click(Sender: TObject);
var
  S: string;
begin
  S:= Table.Filter;
  if InputQuery(sInput, sSetFilter, S) then
    Table.Filter:= S;
end;

procedure TDBMBrowserForm.FilterClick(Sender: TObject);
begin
  with Filter do
  begin
    if Sender <> nil then
      Checked:= not Checked;
    if Checked then
      begin
        Table.SetRangeStart;
        try
          SetKeyValues(RangeStartS);
        finally
          Table.Post;
        end;
        Table.SetRangeEnd;
        try
          SetKeyValues(RangeEndS);
        finally
          Table.Post;
        end;
        Table.ApplyRange;
      end
    else
      Table.CancelRange;
    Table.Filtered:= Checked and (Table.Filter <> '');
  end;
end;

procedure TDBMBrowserForm.Rangestart1Click(Sender: TObject);
begin
  if InputQuery(sInput, sSetFilterRangeStart, RangeStartS) then
  begin
    if Filter.Checked then
      FilterClick(nil);
  end;
end;

procedure TDBMBrowserForm.Rangeend1Click(Sender: TObject);
begin
  if InputQuery(sInput, sSetFilterRangeEnd, RangeEndS) then
  begin
    if Filter.Checked then
      FilterClick(nil);
  end;
end;

procedure TDBMBrowserForm.ExporttoCSV1Click(Sender: TObject);
var
  St: TStream;
  S: string;
  I: Integer;
  Delim: Char;
const
  CRLF = #13#10;
begin
  if SaveCSVDialog.Execute then
  begin
    case (Sender as TComponent).Tag of
      1: Delim:= #9;
    else
     {2: }Delim:= ';';
    end;
    St:= TFileStream.Create(SaveCSVDialog.FileName, fmCreate);
    try
      S:= '';
      for I:= 0 to Table.FieldCount-1 do
        if Table.Fields[I].Visible then
        begin
          if S <> '' then
            S:= S+Delim;
          S:= S+Table.Fields[I].FieldName;
        end;
      S:= S+CRLF;
      St.Write(S[1], Length(S));
      Table.First;
      while not Table.EOF do
      begin
        S:= '';
        for I:= 0 to Table.FieldCount-1 do
          if Table.Fields[I].Visible then
          begin
            if S <> '' then
              S:= S+Delim;
            S:= S+Table.Fields[I].asString;
          end;
        S:= S+CRLF;
        St.Write(S[1], Length(S));
        Table.Next;
      end;
    finally
      St.Free;
    end;
  end;
end;

end.

