{ Copyright (c) 1999 by Mandys Tomas - MandySoft }
{ email: tomas.mandys@2p.cz }
{ URL: http://www.2p.cz }

unit CZStr;

interface
{$IFNDEF VER80}
{$IFNDEF WIN32}
uses
  Objects;

type
  PCZStringCollection=^TCZStringCollection;    { for TurboVision sorting }
  TCZStringCollection=object(TStringCollection)
    function Compare(Key1, Key2: Pointer): Integer; virtual;
  end;
{$ENDIF}
{$ENDIF}
procedure CZConvert(var S: string);                { tranlation from (czKamen) to fake czech sorting (except ch) }

const
  czASCII=0;
  czKamen=1;
  czLatin=2;
  czWin1250=3;
  czISO8859=4;
  czKOI8cs = 5;
  czMacCE = 6;

{ universal char/string translations }
function CZSwitchToC(FromC, ToC: Byte; C: Char): Char;
procedure CZSwitchTo(FromC, ToC: Byte; var S: string);

{ czKamen char/string transations }
function CZUpCase(C: Char; Code: Byte): Char;
function CZLoCase(C: Char; Code: Byte): Char;
function CZUpString(S: string; Code: Byte): string;
function CZLoString(S: string; Code: Byte): string;

implementation

procedure CZConvert; assembler;
asm
{$IFDEF WIN32}
        PUSH    EDI
        PUSH    EBX
	MOV	EDI,S
	LEA	EBX,@@CTable
	MOV	CL,[EDI]
	XOR	CH,CH
	INC	EDI
	JCXZ	@@2
	CLD
@@1:
        MOV	AL,[EDI]
{$IFDEF VER140}
	XLATB
{$ELSE}
	XLAT
{$ENDIF}
	STOSB
	LOOP	@@1
@@2:
        POP     EBX
        POP     EDI
        JMP	@@3
{$ELSE}
	LES	DI,S
	LEA	BX,@@CTable
	MOV	CL,ES:[DI]
	XOR	CH,CH
	INC	DI
	JCXZ	@@2
	CLD
@@1:
        MOV	AL,ES:[DI]
	SEGCS	XLAT
	STOSB
	LOOP	@@1
@@2:	JMP	@@3
{$ENDIF}
@@CTable:      { Prevodni tabulka pro KeybCS2 - Kamenicti }
	DB	$00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
	DB	$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
	DB	$20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
	DB	$30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
	DB	$40,$41,$42,$43,$45,$46,$47,$48,$49,$4B,$4C,$4D,$4E,$4F,$50,$51
	DB	$52,$53,$54,$56,$58,$59,$5A,$5B,$5C,$5D,$5E,$75,$76,$77,$78,$79
	DB	$7A,$41,$42,$43,$45,$46,$47,$48,$49,$4B,$4C,$4D,$4E,$4F,$50,$51
	DB	$52,$53,$54,$56,$58,$59,$5A,$5B,$5C,$5D,$5E,$7B,$7C,$7D,$7E,$7F
	DB	$44,$59,$46,$45,$41,$45,$58,$44,$46,$46,$4E,$4B,$4E,$4E,$41,$41
	DB	$46,$5F,$5F,$51,$51,$51,$59,$59,$5D,$51,$59,$57,$4E,$5D,$55,$58
	DB	$41,$4B,$51,$59,$50,$50,$59,$51,$57,$55,$55,$55,$AC,$AD,$AE,$AF
	DB	$B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF
	DB	$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF
	DB	$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF
	DB	$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF
	DB	$F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF
@@3:
end;

function CZSwitchToC; {$IFNDEF WIN32} assembler; {$ENDIF}
{$IFDEF WIN32}
begin
asm
        PUSH    EBX
        PUSH    EDI
	MOV	ECX,OFFSET @@Kamen   { BASM nechce odecist 2 offsety }
	SUB	ECX,OFFSET @@Ascii   { CX(L) .. velikost tabulky }

        XOR     EAX,EAX
	MOV	AL,FromC
	MUL	CL
	MOV	EDI,OFFSET @@Ascii
	ADD	EDI,EAX            { DI offset na source table }

	MOV	AL,ToC
	MUL	CL
	MOV	EBX,OFFSET @@Ascii
	ADD	EBX,EAX            { BX offset na dest table }

        MOV     AL,C
	CMP	EBX,EDI
	JE	@@2                 { zadna konverze }

	MOV	EDX,EDI
	REPNE	SCASB   { ES:DI .. no segment override is possible }
	JNE	@@2           { neni v table vracim co je v AL }

	MOV	EAX,EDI
	SUB	EAX,EDX         { AL..kolikaty je to byte }
	DEC	AL            { SCASB me zkonci za }
{$IFDEF VER140}
	XLATB                 { [EBX+AL] --> AL}
{$ELSE}
	XLAT
{$ENDIF}

@@2:
        POP     EDI
        POP     EBX
        MOV     Result, AL
        JMP	@@9
{$ELSE}
asm
	MOV	CX,OFFSET @@Kamen   { BASM nechce odecist 2 offsety }
	SUB	CX,OFFSET @@Ascii   { CX(L) .. velikost tabulky }

	MOV	AL,FromC
	MUL	CL
	MOV	DI,OFFSET @@Ascii
	ADD	DI,AX            { DI offset na source table }

	MOV	AL,ToC
	MUL	CL
	MOV	BX,OFFSET @@Ascii
	ADD	BX,AX            { BX offset na dest table }

        MOV     AL,C
	CMP	BX,DI
	JE	@@2                 { zadna konverze }

	MOV	DX,DI
	PUSH	CS
	POP	ES
	REPNE	SCASB   { ES:DI .. no segment override is possible }
	JNE	@@2           { neni v table vracim co je v AL }

	MOV	AX,DI
	SUB	AX,DX         { AL..kolikaty je to byte }
	DEC	AL            { SCASB me zkonci za }
	SEGCS	XLAT          { CS:[BX+AL] --> AL}

@@2:	JMP	@@9
{$ENDIF}
@@Ascii:        { tabulka kodu ASCII }
	DB	'C','u','e','d','a','D','T','c','e','E','L','I','l','l','A','A'
	DB	'E','z','Z','o','o','O','u','U','y','O','U','S','L','Y','R','t'
	DB	'a','i','o','u','n','N','U','O','s','r','r','R'
@@Kamen:        { tabulka kodu Kamenickych }
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@Latin2:       { tabulka kodu Latin 2 }
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@Win1250:      { tabulka kodu Windows 1250 }
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@ISO8859:      { tabulka kodu ISO 8859_2 }
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@Koi8cs:       { tabulka kodu Koi8-cs }
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@MacCE:        { tabulka kodu MacCE }
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@9:
{$IFDEF WIN32}
end;
{$ENDIF}
end;

procedure CZSwitchTo;
var
  I: Integer;
begin
if FromC <> ToC then
  for I:=1 to Length(S) do
    S[I]:=CZSwitchToC(FromC, ToC, S[I]);
end;

{$IFNDEF VER80}
{$IFNDEF WIN32}
function TCZStringCollection.Compare;
var
  S1, S2: string;
begin
  S1:=PString(Key1)^; CZConvert(S1);
  S2:=PString(Key2)^; CZConvert(S2);
  Compare:=TStringCollection.Compare(@S1, @S2);
end;
{$ENDIF}
{$ENDIF}
function CZUpCase; assembler;
asm
	MOV	AL,C
	CMP	AL,'a'
	JB	@@9
	CMP	AL,'z'
	JA	@@1
	SUB	AL,'a'-'A'
	JMP	@@9
@@1:
	CMP	AL,128
	JB	@@9
	CMP	Code,czKamen
	JE	@@Kam
	CMP	Code,czLatin
	JE	@@Lat
        JMP @@9
@@Kam:
	CMP	AL,128+44
	JAE	@@9
	SUB	AL,128
{$IFDEF WIN32}
        PUSH    EBX
	LEA	EBX,@@Kamen
{$IFDEF VER140}
	XLATB
{$ELSE}
	XLAT
{$ENDIF}
        POP     EBX
{$ELSE}
	LEA	BX,@@Kamen
	SEGCS	XLAT
{$ENDIF}
	JMP	@@9
@@Lat:
	JMP	@@9

@@Kamen:
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@9:
end;


function CZLoCase; assembler;
asm
	MOV	AL,C
	CMP	AL,'A'
	JB	@@9
	CMP	AL,'Z'
	JA	@@1
	ADD	AL,'a'-'A'
	JMP	@@9
@@1:
	CMP	AL,128
	JB	@@9
	CMP	Code,czKamen
	JE	@@Kam
	CMP	Code,czLatin
	JE	@@Lat
        JMP	@@9
@@Kam:
	CMP	AL,128+44
	JAE	@@9
	SUB	AL,128
{$IFDEF WIN32}
        PUSH    EBX
	LEA	EBX,@@Kamen
{$IFDEF VER140}
	XLATB
{$ELSE}
	XLAT
{$ENDIF}
        POP     EBX
{$ELSE}
	LEA	BX,@@Kamen
	SEGCS	XLAT
{$ENDIF}
	JMP	@@9
@@Lat:
	JMP	@@9

@@Kamen:
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','','','','','',''
	DB	'','','','','','','','','','','',''
@@9:
end;

function CZUpString;
var
  I: Integer;
begin
for I:=1 to Length(S) do
  S[I]:=CZUpCase(S[I],Code);
CZUpString:=S;
end;

function CZLoString;
var
  I: Integer;
begin
for I:=1 to Length(S) do
  S[I]:=CZLoCase(S[I],Code);
CZLoString:=S;
end;

end.
