unit seltable;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, DB, DBTables;

type
  TSelectTable = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Alias: TComboBox;
    Tables: TListBox;
    ReadOnly: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure AliasChange(Sender: TObject);
    procedure TablesClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TablesDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SelectTable: TSelectTable;

implementation

{$R *.DFM}

procedure TSelectTable.FormCreate(Sender: TObject);
begin
  Session.GetAliasNames(Alias.Items);
end;

procedure TSelectTable.AliasChange(Sender: TObject);
begin
  Tables.Items.Clear;
  Tables.ItemIndex:= -1;
  TablesClick(nil);
  if Alias.Text <> '' then
    Session.GetTableNames(Alias.Text, '*.*',True, True, Tables.Items);
end;

procedure TSelectTable.TablesClick(Sender: TObject);
begin
  OkBtn.Enabled:= Tables.ItemIndex <> -1;
end;

procedure TSelectTable.FormShow(Sender: TObject);
begin
  AliasChange(nil);
end;

procedure TSelectTable.TablesDblClick(Sender: TObject);
begin
  if OkBtn.Enabled then
    ModalResult:= mrOk;
end;

end.
