{ DBMoney components }
{ Copyright (c) 2001 by Mandys Tomas - Mandy Soft }
{ email: tomas.mandys@2p.cz }
{ URL: http://www.2p.cz }

unit DBMoneyF;

interface
uses
  ComObj, Classes, SysUtils, ActiveX, mon2kdbe_TLB, Mon2DFlt_TLB;

type
  TBFRelation = class(TAutoObject, IBFRelation)
    function  RelationEvent(const Source: IBFTable): Integer; safecall;
  end;

  TBFFilter = class(TAutoObject, IBFFilter, IMoneyFilter)
  private
    fFilter: WideString;
    fFilterOptions: Integer;
    fRanges: array[Boolean] of PSafeArray;
    function Get_Filter: WideString; safecall;
    procedure Set_Filter(const Value: WideString); safecall;
    function  Get_FilterOptions: Integer; safecall;
    procedure Set_FilterOptions(Value: Integer); safecall;
  public
    destructor Destroy; override;
    property Filter: WideString read Get_Filter write Set_Filter;
    property FilterOptions: Integer read Get_FilterOptions write Set_FilterOptions;
    function  Top(const Source: IBFTable): Integer; safecall;
    function  Accept(const Source: IBFTable): Integer; safecall;
    function  UseTop: WordBool; safecall;
    procedure SetRange(aWhat: WordBool; SA: PSafeArray); stdcall;
    function AcceptFilter(const Source: IBFTable): Integer;
  end;

implementation
uses
  ComServ;

{ TBFFilter }

destructor TBFFilter.Destroy;
var
  I: Boolean;
begin
  for I:= Low(fRanges) to High(fRanges) do
    if fRanges[I] <> nil then
      SafeArrayDestroy(fRanges[I]);
  inherited;
end;

procedure TBFFilter.SetRange;
begin
  if fRanges[aWhat] <> nil then
    SafeArrayDestroy(fRanges[aWhat]);
  fRanges[aWhat]:= SA;
end;

function TBFFilter.Get_Filter;
begin
  Result:= fFilter;
end;

procedure TBFFilter.Set_Filter;
begin
  fFilter:= Value;
end;

function ExtractFieldNameNoTrim(const Fields: string; var Pos: Integer): string;
var
  I: Integer;
begin
  I := Pos;
  while (I <= Length(Fields)) and (Fields[I] <> '+') do Inc(I);
  Result := {Trim}(Copy(Fields, Pos, I - Pos));
  if (I <= Length(Fields)) and (Fields[I] = '+') then Inc(I);
  Pos := I;
end;

function TBFFilter.Accept(const Source: IBFTable): Integer;
var
  S: string;
  I, J: Integer;
  StartBound, EndBound: Longint;
  V, V2: OleVariant;
begin
  Result:= 0;
  if (Source.Index <> '') and (fRanges[False] <> nil) and (fRanges[True] <> nil) then
  begin
    I:= 1;
    J:= 0;
    SafeArrayGetUBound(fRanges[False], 1, StartBound);
    SafeArrayGetUBound(fRanges[True], 1, EndBound);
    while (I <= Length(Source.Index)) and (Result = 0) do
    begin
      S:= ExtractFieldNameNoTrim(Source.Index, I);
      if S <> '' then
      begin
        V2:= Source.Value[S];
        if J <= StartBound then
        begin
          SafeArrayGetElement(fRanges[False], J, V);
          if V2 < V then
            Result:= 1;
        end;
        if J <= EndBound then
        begin
          SafeArrayGetElement(fRanges[True], J, V);
          if V2 > V then
            Result:= 1;
        end;
        Inc(J);
      end;
    end;
  end;
  if (Result = 0) and (fFilter <> '') then
  begin
    Result:= AcceptFilter(Source);
  end;
//  showmessage('Accept');
{
  bfFilterOK = $00000000;
  bfFilterNoNext = $0000000A;
  bfFilterNoPrev = $00000014;
  bfFilterNotOK = $0000001E;}
end;

function TBFFilter.Top(const Source: IBFTable): Integer;
begin
//  showmessage('Top');
// showmessage(source.source);
//  if fUseTopFlag <> 0 then
  if fRanges[False] <> nil then
    if Source.MultiSeek(fRanges[False]) = bfSeekNone then
      Source.Bottom;
  Result:= $0;
end;

function TBFFilter.UseTop: WordBool;
begin
  Result:= True;
end;

function TBFFilter.Get_FilterOptions: Integer;
begin
  Result:= fFilterOptions;
end;

procedure TBFFilter.Set_FilterOptions(Value: Integer);
begin
  fFilterOptions:= Value;
end;

function TBFFilter.AcceptFilter(const Source: IBFTable): Integer;
begin
  Result:= 0;
//  implementation of additional filter
//    if Source.RecNo mod 4 <> 0 then
//      Result:= $1;   // 0..accept, <>0 noaccept
end;

{ TBFRelation }

function TBFRelation.RelationEvent(const Source: IBFTable): Integer;
begin
//  showmessage('Relation Event');
  Result:= 0 {bfRelationNotFound};
{  bfRelationNotFound = $FFFFFFFF;
  bfRelationOK = $00000000; }
end;

initialization
  TAutoObjectFactory.Create(ComServer, TBFRelation, Class_BFRelation, ciMultiInstance, tmApartment);
  TAutoObjectFactory.Create(ComServer, TBFFilter, Class_BFFilter, ciMultiInstance, tmApartment);
end.
